Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.nortel.soa.oi.openq
Class OpenQImpl

    java.lang.Object
      com.nortel.soa.oi.openq.OpenQImpl

    public class OpenQImpl

extends java.lang.Object

This service offers clients the ability to create contact center contacts that can be queued and routed to agents with the requisite capabilities to handle these contacts based on that contact centers routing/workflow rules. The service allows a single user to login/logout and create, get or drop contacts. Contacts created using this service are associated with a specific RoutePoint, the "OpenQRoutePointAddress". This allows contacts created using this service to be reported on separately from other contacts.
This service also supports some service provider specific notifications, which are possible using a back to back web service model. I.e. This OpenQ service is paired with a `NotificationConsumer` service running on the client. When a client issues a request for notifications, it provides the endpoint information of its NotificationConsumer service implementation such that when a notification occurs, the OpenQ service can invoke the clients NotificationConsumers notify operation.

Operations: View WSDL TODO

Field Summary
`static java.lang.String` | `OI_OPENQ_CONTACT_TYPE`
`static java.lang.String` | `OI_OPENQ_DEFAULT_OUT_OF_PROVIDER`
`static java.lang.String` | `OI_OPENQ_PROVIDER_INTRINSIC_DEFAULT_VALUE`
`static java.lang.String` | `OI_OPENQ_PROVIDER_NAME`
`static java.lang.String` | `OI_OPENQ_ROUTEPOINT`
`static java.lang.String` | `PROVIDER_INTRINSIC_KEY_VALUE`

Constructor Summary
`OpenQImpl()`

Method Summary
`java.lang.String` | `addDefaultTreatmentListener(java.lang.String consumerEndpoint, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Add default treatment listener
`java.lang.String` | `addForceDisconnectListener(java.lang.String consumerEndpoint, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Add force disconnect listener
`java.lang.String` | `addServiceProviderStatusListener(java.lang.String consumerEndpoint, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Add service provider status listener
`com.nortel.soa.oi.cct.types.Contact` | `createContact(com.nortel.soa.oi.cct.types.Provider provider, java.lang.String externalContactId, Reason contactReasonCode, Address outOfProviderAddress, java.lang.String outOfProviderExternalId, Reason outOfProviderReasonCode, Address routePointAddress, java.lang.String routePointAddressExternalId, Reason routePointAddressReasonCode, ContactTypeArray contactTypes, IntrinsicArray intrinsics, SsoToken ssoToken)`
`com.nortel.soa.oi.cct.types.Contact` | `createOQContact(java.lang.String externalContactId, java.lang.String outOfProviderAddressName, IntrinsicArray intrinsics, SsoToken ssoToken)` Create an OpenQ contact
`boolean` | `dropContact(com.nortel.soa.oi.cct.types.Contact contact, com.nortel.soa.oi.cct.types.SsoToken ssoToken)`
`boolean` | `dropOQContact(java.lang.String externalContactId, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Drop an OpenQ contact
`com.nortel.soa.oi.cct.types.Contact` | `getContact(com.nortel.soa.oi.cct.types.Provider provider, java.lang.String externalContactId, SsoToken ssoToken)`
`com.nortel.soa.oi.cct.types.Contact` | `getOQContact(java.lang.String externalContactId, SsoToken ssoToken)` Get an OpenQ contact
`java.lang.String` | `getVersion()`
`GetVersionResponse` | `getVersion(GetVersionRequest parameters)`
`SsoToken` | `logIn(AuthenticationLevel authenticationLevel)` Login to OpenQ service
`boolean` | `logOff(SsoToken ssoToken)` Log off from OpenQ service
`boolean` | `removeDefaultTreatmentListener(java.lang.String subscriptionRef, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Remove default treatment listener subscription
`boolean` | `removeForceDisconnectListener(java.lang.String subscriptionRef, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Remove force disconnect listener subscription
`boolean` | `removeServiceProviderStatusListener(java.lang.String subscriptionRef, com.nortel.soa.oi.cct.types.SsoToken ssoToken)` Remove service provider status listener subscription
`java.lang.String` | `subscribe(java.lang.String consumerEndpoint, ListenersPolicyType listenerPolicy, SsoToken ssoToken)` Subscribe for OpenQ service notifications
`boolean` | `unsubscribe(java.lang.String subscriptionRef, SsoToken ssoToken)` UnSubscribe from OpenQ service notifications

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### OI_OPENQ_PROVIDER_NAME

    public static final java.lang.String OI_OPENQ_PROVIDER_NAME

See Also:
  Constant Field Values

### OI_OPENQ_ROUTEPOINT

    public static final java.lang.String OI_OPENQ_ROUTEPOINT

See Also:
  Constant Field Values

### OI_OPENQ_CONTACT_TYPE

    public static final java.lang.String OI_OPENQ_CONTACT_TYPE

See Also:
  Constant Field Values

### OI_OPENQ_DEFAULT_OUT_OF_PROVIDER

    public static final java.lang.String OI_OPENQ_DEFAULT_OUT_OF_PROVIDER

See Also:
  Constant Field Values

### PROVIDER_INTRINSIC_KEY_VALUE

    public static final java.lang.String PROVIDER_INTRINSIC_KEY_VALUE

See Also:
  Constant Field Values

### OI_OPENQ_PROVIDER_INTRINSIC_DEFAULT_VALUE

    public static final java.lang.String OI_OPENQ_PROVIDER_INTRINSIC_DEFAULT_VALUE

See Also:
  Constant Field Values

Constructor Detail

### OpenQImpl

    public OpenQImpl()

Method Detail

### logIn

    public SsoToken logIn(AuthenticationLevel authenticationLevel)
                   throws LogInFailedFault

  Login to OpenQ service

  Operation Summary:
  Log into OpenQ service with OpenQ user credentials and returns single sign on token allowing access to OpenQ services

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `{@link` - AuthenticationLevel} detailing user information
  Returns:
    `SsoToken`
  Throws:
    `LogInFailedFault`

### logOff

    public boolean logOff(SsoToken ssoToken)
                   throws LogOffFailedFault

  Log off from OpenQ service

  Operation Summary:
  Log off OpenQ service

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `{@link` - SsoToken} detailing session information to log off.
  Returns:
    boolean indicating successful logOff if true
  Throws:
    `LogOffFailedFault`

### createContact

    public com.nortel.soa.oi.cct.types.Contact createContact(com.nortel.soa.oi.cct.types.Provider provider,
                                                             java.lang.String externalContactId,
                                                             Reason contactReasonCode,
                                                             Address outOfProviderAddress,
                                                             java.lang.String outOfProviderExternalId,
                                                             Reason outOfProviderReasonCode,
                                                             Address routePointAddress,
                                                             java.lang.String routePointAddressExternalId,
                                                             Reason routePointAddressReasonCode,
                                                             ContactTypeArray contactTypes,
                                                             IntrinsicArray intrinsics,
                                                             SsoToken ssoToken)
                                                      throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### createOQContact

    public com.nortel.soa.oi.cct.types.Contact createOQContact(java.lang.String externalContactId,
                                                               java.lang.String outOfProviderAddressName,
                                                               IntrinsicArray intrinsics,
                                                               SsoToken ssoToken)
                                                        throws CreateOQContactFailedFault

  Create an OpenQ contact

  Operation Summary:
  Create an OpenQ contact with contact Id and out of provider address as provided. In addition, intrinsics in key value pairs can be provided to be associated with this contact

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the contacts external contact id
    `the` - String detailing the out of provider address associated with this contact
    `an` - `IntrinsicArray` detailing any key value pairs representing intrinsics associated with this contact
    `an` - `SsoToken`
  Returns:
    `com.nortel.soa.oi.cct.types.Contact` representing the newly created OpenQ contact
  Throws:
    `CreateOQContactFailedFault`

### dropContact

    public boolean dropContact(com.nortel.soa.oi.cct.types.Contact contact,
                               com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                        throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### dropOQContact

    public boolean dropOQContact(java.lang.String externalContactId,
                                 com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                          throws DropOQContactFailedFault

  Drop an OpenQ contact

  Operation Summary:
  Drops an OpenQ contact with contact Id equal to that of one provided

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the external contact id of the contact to drop
    `an` - `SsoToken`
  Returns:
    boolean indicating successful dropOQContact if true
  Throws:
    `DropOQContactFailedFault`

### getContact

    public com.nortel.soa.oi.cct.types.Contact getContact(com.nortel.soa.oi.cct.types.Provider provider,
                                                          java.lang.String externalContactId,
                                                          SsoToken ssoToken)
                                                   throws java.lang.Exception

  Throws:
    `java.lang.Exception`

### getOQContact

    public com.nortel.soa.oi.cct.types.Contact getOQContact(java.lang.String externalContactId,
                                                            SsoToken ssoToken)
                                                     throws GetOQContactFailedFault

  Get an OpenQ contact

  Operation Summary:
  Retreive an OpenQ contact with contact Id equal to that provided

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the contacts external contact id
    `an` - `SsoToken`
  Returns:
    `com.nortel.soa.oi.cct.types.Contact` representing the OpenQ contact
  Throws:
    `GetOQContactFailedFault`

### addServiceProviderStatusListener

    public java.lang.String addServiceProviderStatusListener(java.lang.String consumerEndpoint,
                                                             com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                                                      throws AddServiceProviderStatusListenerFailedFault

  Add service provider status listener

  Operation Summary:
  Subscribes for service provider status notifications

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the clients endpoint where the "notify" operation is hosted
    `an` - `SsoToken`
  Returns:
    String detailing the subscription id representing this listener
  Throws:
    `AddServiceProviderStatusListenerFailedFault`

### removeServiceProviderStatusListener

    public boolean removeServiceProviderStatusListener(java.lang.String subscriptionRef,
                                                       com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                                                throws RemoveServiceProviderStatusListenerFailedFault

  Remove service provider status listener subscription

  Operation Summary:
  Unsubscribes service provider status notifications

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the subscription to unsubscribe.
    `an` - `SsoToken`
  Returns:
    boolean indicating successful unsubscribe if true
  Throws:
    `RemoveServiceProviderStatusListenerFailedFault`

### addDefaultTreatmentListener

    public java.lang.String addDefaultTreatmentListener(java.lang.String consumerEndpoint,
                                                        com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                                                 throws AddDefaultTreatmentListenerFailedFault

  Add default treatment listener

  Operation Summary:
  Subscribes for default treatment notifications

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the clients endpoint where the "notify" operation is hosted
    `an` - `SsoToken`
  Returns:
    String detailing the subscription id representing this listener
  Throws:
    `AddDefaultTreatmentListenerFailedFault`

### removeDefaultTreatmentListener

    public boolean removeDefaultTreatmentListener(java.lang.String subscriptionRef,
                                                  com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                                           throws RemoveDefaultTreatmentListenerFailedFault

  Remove default treatment listener subscription

  Operation Summary:
  Unsubscribes default treatment notifications

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the subscription to unsubscribe.
    `an` - `SsoToken`
  Returns:
    boolean indicating successful unsubscribe if true
  Throws:
    `RemoveDefaultTreatmentListenerFailedFault`

### addForceDisconnectListener

    public java.lang.String addForceDisconnectListener(java.lang.String consumerEndpoint,
                                                       com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                                                throws AddForceDisconnectListenerFailedFault

  Add force disconnect listener

  Operation Summary:
  Subscribes for force disconnect notifications

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the clients endpoint where the "notify" operation is hosted
    `an` - `SsoToken`
  Returns:
    String detailing the subscription id representing this listener
  Throws:
    `AddForceDisconnectListenerFailedFault`

### removeForceDisconnectListener

    public boolean removeForceDisconnectListener(java.lang.String subscriptionRef,
                                                 com.nortel.soa.oi.cct.types.SsoToken ssoToken)
                                          throws RemoveForceDisconnectListenerFailedFault

  Remove force disconnect listener subscription

  Operation Summary:
  Unsubscribes force disconnect notifications

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the subscription to unsubscribe.
    `an` - `SsoToken`
  Returns:
    boolean indicating successful unsubscribe if true
  Throws:
    `RemoveForceDisconnectListenerFailedFault`

### subscribe

    public java.lang.String subscribe(java.lang.String consumerEndpoint,
                                      ListenersPolicyType listenerPolicy,
                                      SsoToken ssoToken)
                               throws SubscribeFailedFault

  Subscribe for OpenQ service notifications

  Operation Summary:
  Subscribes for any combination for service provider status, default treatment and force disconnect notifications. This operation offers same functionality of the other OpenQ service "Add" listener operations

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the clients endpoint where the "notify" operation is hosted
    `an` - `SsoToken`
  Returns:
    String detailing the subscription id representing this subscription
  Throws:
    `SubscribeFailedFault`
  See Also:
    `addServiceProviderStatusListener`, `addDefaultTreatmentListener`, `addForceDisconnectListener`

### unsubscribe

    public boolean unsubscribe(java.lang.String subscriptionRef,
                               SsoToken ssoToken)
                        throws UnsubscribeFailedFault

  UnSubscribe from OpenQ service notifications

  Operation Summary:
  Unsubscribes subscription so that notifications assocaited with that subscription are no longer received

  Sample Usage:
  `
  `

  SOAP Request/Response:
  Sample Request
  Sample Response

  Parameters:
    `the` - String detailing the subscription to unsubscribe associated notifications
    `an` - `SsoToken`
  Returns:
    boolean indicating successful unsubscribe if true
  Throws:
    `UnsubscribeFailedFault`
  See Also:
    `removeServiceProviderStatusListener`, `removeDefaultTreatmentListener`, `removeForceDisconnectListener`

### getVersion

    public GetVersionResponse getVersion(GetVersionRequest parameters)
                                  throws GetVersionFault

  Throws:
    `GetVersionFault`

### getVersion

    public java.lang.String getVersion()
                                throws GetVersionFault

  Throws:
    `GetVersionFault`

Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD